Debian Bug report logs - #263426
gcc-3.3 on i386, mipsel and sparc is built against binutils 2.15 and will try to use --as-needed

version graph

Package: gcc-3.3; Maintainer for gcc-3.3 is Philipp Kern <pkern@debian.org>;

Reported by: Andreas Metzler <ametzler@downhill.at.eu.org>

Date: Wed, 4 Aug 2004 10:48:01 UTC

Severity: serious

Found in version 1:3.3.4-7

Fixed in version gcc-3.3/1:3.3.4-9

Done: Matthias Klose <doko@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-release@lists.debian.org, Debian GCC maintainers <debian-gcc@lists.debian.org>:
Bug#263426; Package gcc-3.3. Full text and rfc822 format available.

Acknowledgement sent to Andreas Metzler <ametzler@downhill.at.eu.org>:
New Bug report received and forwarded. Copy sent to debian-release@lists.debian.org, Debian GCC maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Andreas Metzler <ametzler@downhill.at.eu.org>
To: submit@bugs.debian.org
Subject: gcc-3.3 on i386, mipsel and sparc is built against binutils 2.15 and will try to use --as-needed
Date: Wed, 4 Aug 2004 12:33:01 +0200
Package: gcc-3.3
Version: 1:3.3.4-7
Severity: serious

This bug report is the result of a conversation on #debian-release, as
IRC is volatile I capture it now.

If gcc-3.3 is built on a machine with binutils 2.15 gcc's ./configure
test
| checking linker --as-needed support... yes
will succeed and the resulting gcc will use --as-needed when linking,
although it does not depend on binutils (>=2.15). James Troup noticed
this on sparc "because it's broken the buildds".

Checking the buildlogs yielded that s390, ia64, arm are built with
older binutils, mips, mipsel, alpha and sparc are built with 2.15.
Heuristically I also tested with
dpkg --fsys-tarfile gcc-3.3.deb | grep -- --as-needed
which showed matches only in i386, mipsel and sparc

This breaks the compiler completely, minimal testcase:
$ echo 'int main () { return(0) ; }' > foo.c
$ gcc -Wall -o foo foo.c
/usr/bin/ld: unrecognized option '--as-needed'
/usr/bin/ld: use the --help option for usage information
collect2: ld returned 1 exit status


Possible "solutions":
1) Delay gcc-3.3's entry into sarge by making it Depend on binutils
2.15.

2) Make binary NMUs of the broken binaries. (Too late for today's
dinstall, mipsel takes more than 8 hours)

3) Ignore this bug and temporarily live with a non-working gcc in
sarge.

Personally I think 3 is not acceptable for gcc-3.3 but might be for
gcc-3.4 .(#263019).
                  cu andreas
-- 
"See, I told you they'd listen to Reason," [SPOILER] Svfurlr fnlf,
fuhggvat qbja gur juveyvat tha.
Neal Stephenson in "Snow Crash"



Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC maintainers <debian-gcc@lists.debian.org>:
Bug#263426; Package gcc-3.3. Full text and rfc822 format available.

Acknowledgement sent to Adrian Bunk <bunk@fs.tum.de>:
Extra info received and forwarded to list. Copy sent to Debian GCC maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 263426@bugs.debian.org (full text, mbox):

From: Adrian Bunk <bunk@fs.tum.de>
To: 263426-submitter@bugs.debian.org
Cc: 263426@bugs.debian.org
Subject: Your second suggestion is flawed
Date: Thu, 5 Aug 2004 13:20:16 +0200
Hi Andreas,

your second suggestion for this bug ("gcc-3.3 on i386, mipsel and sparc  
is built against binutils 2.15 and will try to use --as-needed") is 
flawed, since this will break again with any binary NMU or other update 
for gcc-3.3.

The only real choices are:
1. update the dependency on binutils
2. hack gcc/configure.in to not define HAVE_LD_AS_NEEDED

The preferred approach at least in the long term is definitely the first 
one.

cu
Adrian

-- 

       "Is there not promise of rain?" Ling Tan asked suddenly out
        of the darkness. There had been need of rain for many days.
       "Only a promise," Lao Er said.
                                       Pearl S. Buck - Dragon Seed




Message sent on to Andreas Metzler <ametzler@downhill.at.eu.org>:
Bug#263426. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Debian GCC maintainers <debian-gcc@lists.debian.org>:
Bug#263426; Package gcc-3.3. Full text and rfc822 format available.

Acknowledgement sent to Daniel Jacobowitz <dan@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian GCC maintainers <debian-gcc@lists.debian.org>. Full text and rfc822 format available.

Message #18 received at 263426@bugs.debian.org (full text, mbox):

From: Daniel Jacobowitz <dan@debian.org>
To: Andreas Metzler <ametzler@downhill.at.eu.org>, 263426@bugs.debian.org
Subject: Re: Bug#263426: gcc-3.3 on i386, mipsel and sparc is built against binutils 2.15 and will try to use --as-needed
Date: Thu, 5 Aug 2004 11:52:24 -0400
On Wed, Aug 04, 2004 at 12:33:01PM +0200, Andreas Metzler wrote:
> Possible "solutions":
> 1) Delay gcc-3.3's entry into sarge by making it Depend on binutils
> 2.15.

For the record, I consider this to be the better idea.

-- 
Daniel Jacobowitz



Tags added: pending Request was from Matthias Klose <doko@cs.tu-berlin.de> to control@bugs.debian.org. Full text and rfc822 format available.

Reply sent to Matthias Klose <doko@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Andreas Metzler <ametzler@downhill.at.eu.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #25 received at 263426-close@bugs.debian.org (full text, mbox):

From: Matthias Klose <doko@debian.org>
To: 263426-close@bugs.debian.org
Subject: Bug#263426: fixed in gcc-3.3 1:3.3.4-9
Date: Sat, 14 Aug 2004 21:32:13 -0400
Source: gcc-3.3
Source-Version: 1:3.3.4-9

We believe that the bug you reported is fixed in the latest version of
gcc-3.3, which is due to be installed in the Debian FTP archive:

cpp-3.3-doc_3.3.4-9_all.deb
  to pool/main/g/gcc-3.3/cpp-3.3-doc_3.3.4-9_all.deb
cpp-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/cpp-3.3_3.3.4-9_i386.deb
fixincludes_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/fixincludes_3.3.4-9_i386.deb
g++-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/g++-3.3_3.3.4-9_i386.deb
g77-3.3-doc_3.3.4-9_all.deb
  to pool/main/g/gcc-3.3/g77-3.3-doc_3.3.4-9_all.deb
g77-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/g77-3.3_3.3.4-9_i386.deb
gcc-3.3-base_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/gcc-3.3-base_3.3.4-9_i386.deb
gcc-3.3-doc_3.3.4-9_all.deb
  to pool/main/g/gcc-3.3/gcc-3.3-doc_3.3.4-9_all.deb
gcc-3.3_3.3.4-9.diff.gz
  to pool/main/g/gcc-3.3/gcc-3.3_3.3.4-9.diff.gz
gcc-3.3_3.3.4-9.dsc
  to pool/main/g/gcc-3.3/gcc-3.3_3.3.4-9.dsc
gcc-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/gcc-3.3_3.3.4-9_i386.deb
gcj-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/gcj-3.3_3.3.4-9_i386.deb
gij-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/gij-3.3_3.3.4-9_i386.deb
gnat-3.3-doc_3.3.4-9_all.deb
  to pool/main/g/gcc-3.3/gnat-3.3-doc_3.3.4-9_all.deb
gnat-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/gnat-3.3_3.3.4-9_i386.deb
gobjc-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/gobjc-3.3_3.3.4-9_i386.deb
gpc-2.1-3.3-doc_3.3.4.20040516-9_all.deb
  to pool/main/g/gcc-3.3/gpc-2.1-3.3-doc_3.3.4.20040516-9_all.deb
gpc-2.1-3.3_3.3.4.20040516-9_i386.deb
  to pool/main/g/gcc-3.3/gpc-2.1-3.3_3.3.4.20040516-9_i386.deb
libffi2-dev_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libffi2-dev_3.3.4-9_i386.deb
libffi2_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libffi2_3.3.4-9_i386.deb
libg2c0-dev_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libg2c0-dev_3.3.4-9_i386.deb
libg2c0_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libg2c0_3.3.4-9_i386.deb
libgcj-common_3.3.4-9_all.deb
  to pool/main/g/gcc-3.3/libgcj-common_3.3.4-9_all.deb
libgcj4-awt_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libgcj4-awt_3.3.4-9_i386.deb
libgcj4-common_3.3.4-9_all.deb
  to pool/main/g/gcc-3.3/libgcj4-common_3.3.4-9_all.deb
libgcj4-dev_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libgcj4-dev_3.3.4-9_i386.deb
libgcj4_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libgcj4_3.3.4-9_i386.deb
libobjc1_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libobjc1_3.3.4-9_i386.deb
libstdc++5-3.3-dbg_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libstdc++5-3.3-dbg_3.3.4-9_i386.deb
libstdc++5-3.3-dev_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libstdc++5-3.3-dev_3.3.4-9_i386.deb
libstdc++5-3.3-doc_3.3.4-9_all.deb
  to pool/main/g/gcc-3.3/libstdc++5-3.3-doc_3.3.4-9_all.deb
libstdc++5-3.3-pic_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libstdc++5-3.3-pic_3.3.4-9_i386.deb
libstdc++5_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/libstdc++5_3.3.4-9_i386.deb
protoize_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/protoize_3.3.4-9_i386.deb
treelang-3.3_3.3.4-9_i386.deb
  to pool/main/g/gcc-3.3/treelang-3.3_3.3.4-9_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 263426@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Matthias Klose <doko@debian.org> (supplier of updated gcc-3.3 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Fri, 13 Aug 2004 12:53:36 +0200
Source: gcc-3.3
Binary: gcc-3.3-nof gcc-3.3 libobjc1 libgcc1 lib64g2c0 libstdc++5-3.3-doc libgcj4 gpc-2.1-3.3-doc libstdc++5 cpp-3.3-doc protoize gcc-3.3-hppa64 cpp-3.3 libgcj4-awt libstdc++5-3.3-dbg g77-3.3-doc gpc-2.1-3.3 g77-3.3 libgcj4-dev gcc-3.3-doc libgnat-3.15 lib64objc1 lib64ffi2 libstdc++5-3.3-dev libffi2-dev gcj-3.3 libgcj-common gobjc-3.3 lib64stdc++5 gcc-3.3-soft-float lib64gcj4 treelang-3.3 libg2c0-dev lib64gcc1 fastjar lib64gnat3.15 fixincludes libg2c0 gij-3.3 libstdc++5-3.3-pic gcc-3.3-base g++-3.3 gnat-3.3 libffi2 gnat-3.3-doc libgcj4-common
Architecture: source i386 all
Version: 1:3.3.4-9
Distribution: unstable
Urgency: high
Maintainer: Debian GCC maintainers <debian-gcc@lists.debian.org>
Changed-By: Matthias Klose <doko@debian.org>
Description: 
 cpp-3.3    - The GNU C preprocessor
 cpp-3.3-doc - Documentation for the GNU C preprocessor (cpp)
 fixincludes - Fix non-ANSI header files
 g++-3.3    - The GNU C++ compiler
 g77-3.3    - The GNU Fortran 77 compiler
 g77-3.3-doc - Documentation for the GNU Fortran compiler (g77)
 gcc-3.3    - The GNU C compiler
 gcc-3.3-base - The GNU Compiler Collection (base package)
 gcc-3.3-doc - Documentation for the GNU compilers (gcc, gobjc, g++)
 gcj-3.3    - The GNU compiler for Java(TM)
 gij-3.3    - The GNU Java bytecode interpreter
 gnat-3.3   - The GNU Ada compiler
 gnat-3.3-doc - Documentation for the GNU Ada compiler (gnat)
 gobjc-3.3  - The GNU Objective-C compiler
 gpc-2.1-3.3 - The GNU Pascal compiler
 gpc-2.1-3.3-doc - Documentation for the GNU Pascal compiler (gpc)
 libffi2    - Foreign Function Interface library runtime
 libffi2-dev - Foreign Function Interface library (development files)
 libg2c0    - Runtime library for GNU Fortran 77 applications
 libg2c0-dev - GNU Fortran 77 library development
 libgcj-common - Java runtime library (common files)
 libgcj4    - Java runtime library for use with gcj
 libgcj4-awt - AWT peer runtime libraries for use with gcj
 libgcj4-common - Java runtime library for use with gcj (jar files)
 libgcj4-dev - Java development headers and static library for use with gcj
 libobjc1   - Runtime library for GNU Objective-C applications
 libstdc++5 - The GNU Standard C++ Library v3
 libstdc++5-3.3-dbg - The GNU Standard C++ Library v3 (debugging files)
 libstdc++5-3.3-dev - The GNU Standard C++ Library v3 (development files)
 libstdc++5-3.3-doc - The GNU Standard C++ Library v3 (documentation files)
 libstdc++5-3.3-pic - The GNU Standard C++ Library v3 (shared library subset kit)
 protoize   - Create/remove ANSI prototypes from C code
 treelang-3.3 - The GNU Treelang compiler
Closes: 261563 263426 265522 265649
Changes: 
 gcc-3.3 (1:3.3.4-9) unstable; urgency=high
 .
   * Tighten binutils build-dependency/dependency to (>= 2.15).
     Closes: #263426.
   * Tighten glibc dependency, needed at least for m68k to avoid
     regressions with new binutils.
   * Fix typo for libgcj-awt suggestions (closes: #261563).
   * Update i386-mtune patch to fix regressions (James Troup).
   * Reenable the testsuite.
   * For gcj-3.3 add a dependency on libgcj4-common (closes: #265522).
   * Fix libgcj4-common doc dir symlink (closes: #265649).
Files: 
 364999818a93416cfbf66b42f2752b1b 2165 devel standard gcc-3.3_3.3.4-9.dsc
 b97356f2626834cb4e4009957a08177a 3530693 devel standard gcc-3.3_3.3.4-9.diff.gz
 a60ecea79262a744299adbd6981b56a6 176648 doc optional cpp-3.3-doc_3.3.4-9_all.deb
 68882e693f0bc35717b81deafc9c6ac7 1330850 libs optional libgcj4-common_3.3.4-9_all.deb
 cea9c9b2b9ba3f5bac60c5aa723bc0e5 1172 libs optional libgcj-common_3.3.4-9_all.deb
 18ab770268b24fb6831d3666b97da5d3 3269722 doc optional libstdc++5-3.3-doc_3.3.4-9_all.deb
 feeef379fb320abd38fef3e03659a87d 628572 doc optional g77-3.3-doc_3.3.4-9_all.deb
 8bcd391a44f2cda168994e2389864cc7 707512 doc optional gnat-3.3-doc_3.3.4-9_all.deb
 6e99bdf36f19fa4936fba674a5f20dd6 1204194 doc optional gpc-2.1-3.3-doc_3.3.4.20040516-9_all.deb
 95d6808f2023564748c380a3fa420652 1336160 doc optional gcc-3.3-doc_3.3.4-9_all.deb
 9e965f56b0655d5b60a5b9625fc87e16 147122 devel required gcc-3.3-base_3.3.4-9_i386.deb
 c17a7aeaf40b1256c98f0ff036616689 1391008 interpreters standard cpp-3.3_3.3.4-9_i386.deb
 16a500982a21f3e59596804b4bf394de 26640 devel optional protoize_3.3.4-9_i386.deb
 be680f0ca03fe2f82ad4c69f20439782 74614 devel optional fixincludes_3.3.4-9_i386.deb
 8473a95fd90719a2d8f987dc4298c69d 1467246 devel optional gobjc-3.3_3.3.4-9_i386.deb
 c0b920d50f06c5f901b1fa2a18454603 136270 libs optional libobjc1_3.3.4-9_i386.deb
 56a9e1f683bbfa7ce0d5655f83a8158f 12980 devel optional gij-3.3_3.3.4-9_i386.deb
 abd8a67668bb44b7910f4e9c34fea98b 2586190 libs optional libgcj4_3.3.4-9_i386.deb
 6078cbecf2654bade0251b1e4ecd27ea 62544 libs optional libgcj4-awt_3.3.4-9_i386.deb
 4c75cd5084e5849507fc65f4b849eddd 1734726 devel optional gcj-3.3_3.3.4-9_i386.deb
 fb445a738a71de24906f0165ac366f49 4750748 libdevel optional libgcj4-dev_3.3.4-9_i386.deb
 ff35e77a3f37695b85020769fea3f49c 71034 libs optional libffi2_3.3.4-9_i386.deb
 8e301aca2c462d0db0df8d902083c030 11194 libdevel optional libffi2-dev_3.3.4-9_i386.deb
 72a406c3a9b23251ce4dc0eace3c054d 1776176 devel standard g++-3.3_3.3.4-9_i386.deb
 d053c8e1704bda4b30b2f043b5174f45 292436 base required libstdc++5_3.3.4-9_i386.deb
 8f5786f4d25fe70c8c7440fc2dcb7050 774574 libdevel standard libstdc++5-3.3-dev_3.3.4-9_i386.deb
 c17d7a16a96d4df9239f49ed74f7591a 325332 libdevel extra libstdc++5-3.3-pic_3.3.4-9_i386.deb
 94737a4e6a38f0951f1faf178137eaf5 4877536 libdevel extra libstdc++5-3.3-dbg_3.3.4-9_i386.deb
 8e626e9d368d516a5a090d77b9d0a4c4 50562 libs optional libg2c0_3.3.4-9_i386.deb
 9a2fa5480eb355fa5d54a01fd9097783 1549082 devel optional g77-3.3_3.3.4-9_i386.deb
 d7ee87a25cebe3d2f0741f816a8090dd 66598 libdevel optional libg2c0-dev_3.3.4-9_i386.deb
 54e6d407146ec2485c4b04a50f76da34 6216458 devel optional gnat-3.3_3.3.4-9_i386.deb
 d38b3a02337c07ef049771618a006b76 1321324 devel optional treelang-3.3_3.3.4-9_i386.deb
 5dfc44ff3ac31b48bd68cfb00bdc74ac 1938964 devel optional gpc-2.1-3.3_3.3.4.20040516-9_i386.deb
 40943b55d730cf7681817fae53b40e9f 1563226 devel standard gcc-3.3_3.3.4-9_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.2.5 (GNU/Linux)

iD8DBQFBHq/9StlRaw+TLJwRAr96AKCuk5VJDKoO1qg9ZMMgb2J5bNk3HgCghYiJ
Mlcow4PegSNZVNc1TF2kNhM=
=0LnH
-----END PGP SIGNATURE-----




Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 13:58:04 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.